<?php 

namespace App\Controller;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class Reports 
{
  private $reports;

  public function __construct(\App\Service\Reports $reports) {
    $this->reports = $reports;
  }

  public function exportPDF(Request $request, Response $response) {
    try {
      $params = $request->getParsedBody();
      $pdfOutput  = $this->reports->exportPDF($params);

      if (empty($pdfOutput)) {
        throw new \Exception('Nenhum conteúdo de PDF gerado.');
      }

      $response->getBody()->write($pdfOutput);

      return $response->withHeader('Content-Type', 'application/pdf');
    } catch (\Exception $e) {
      $response->getBody()->write(json_encode([
        'error'   => true,
        'message' => $e->getMessage(),
        'data'    => []
      ]));
      
      return $response->withHeader('Content-Type', 'application/json');
    }
  }
}