import {
  alertService,
} from '@/helpers/AlertService';
import {
  Http,
} from '@zeedhi/core';

class ReportsController {
  public async exportsReportsPDF(title: string, params: any) {
    try {
      params.title = title;
      const { data, error, message } = await Http.post('/reports/exportPDF', params, { responseType: 'arraybuffer' });

      if (error) throw new Error(message);

      const blob = new Blob([data], { type: 'application/pdf' });
      const link = document.createElement('a');
      link.href = window.URL.createObjectURL(blob);
      link.download = `${title}.pdf`;
      link.click();
      window.URL.revokeObjectURL(link.href);
    } catch (error) {
      if (error instanceof Error) {
        alertService('error', error.message, 'red');
      }
    }
  }
}

export default new ReportsController();
